#pragma once
#include <vector> 
#include <map> 
#include <math.h>    
#include <BWAPI.h>
#include <algorithm>

#define WALK_TILE 8

using namespace std;

class AStar {
    class Node;
	  private:   
        BWAPI::Game* Broodwar;

        map<pair<int,int>,Node*> open_pos;
        multimap<double,Node*>   open_f;
        map<pair<int,int>,Node*> closed;
        
        void deleteAll();

        double heuristic(pair<int, int> start, pair<int, int> end);
        int getLowest();
        vector<Node*> getNeighbors(Node* current);
        vector<BWAPI::Position> getPath(Node* current);

	  public:
        AStar(BWAPI::Game* game);
        ~AStar(void);

        vector<BWAPI::Position> find(BWAPI::Position start, BWAPI::Position end);
		
};

class AStar::Node {
    public:
        Node(pair<int, int> p) {
            pos = p;
            f = 0;
            g = INT_MAX;
            prev = NULL;
        };
        pair<int, int> pos;
        double f;
        double g;
        double cost;
        Node* prev;
};