#include "Matrix.h"

Matrix::Matrix(int a,int b) {
	h = a;
	w = b;
	data.resize(w*h);
}

/* generate radnom values in matrix */
void Matrix::random(int x) {
	srand (time(NULL));
	double factor = 1/sqrt((double)x);
	for (int i = 0; i < data.size(); i++) {
		data[i] = ((((double)rand() / (RAND_MAX)) * 2) - 1) * factor *0.01;
	}
}

/* load matrix from file */
bool Matrix::load(string file) {
	input.open(file.c_str());
  if (input != NULL) {
      double x; 
      input >> x;
      if (!input.eof()) {
        double i = 0;
        data[i] = x;
        while(!input.eof() && (i < data.size()-1)) {
            i++;
            input >> x;   
	          data[i] = x;
	      }  
      } else {
        input.close();
        return false;
      }
	    input.close();
      return true;
  }
  return false;
}

/* save matrix in file */
void Matrix::save(string file) {
	output.open(file.c_str());
  if (output != NULL) {
    for (int i = 0; i < data.size(); i++) {
		    output << data[i] << " ";
	  }
    output.close();
  }
}

/* generate transparent matrix */
Matrix* Matrix::transp() {
	Matrix* tmp = new Matrix (w,h);

	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			tmp->set(i+j*h,data[j+i*w]);
		}
	}

	return tmp;	
}

/* multiply vector and matrix (with/without sigmoid on result) */
vector<double> Matrix::multi(vector<double> in, bool sig) {
	vector<double> out;
	out.resize(h);

	for (int i = 0; i < h; i++) {
		double sum = 0;
		for (int k = 0; k < w; k++){
			sum += data[k+i*w] * in[k];
		}
		if (sig) out[i] = 1/(1+pow(exp(1.0),-sum));
		else out[i] = sum;
    }

	return out;
}