#pragma once
#include "ActorCritic.h"
#include "AStar.h"
#include <BWAPI.h>
#include <BWTA.h>
#include <fstream>
#include <sstream>
#include <cmath>

#include <stdlib.h>
#include <time.h>

class Scout {
    private: 
        BWAPI::Game* Broodwar;
        ofstream out;
        ifstream in;

        int iterationCounter;
   
        /* Actor-Critic */
        //ActorCritic *ac;
        double gamma;
        double exploration;
        bool canLearn;
        vector<double> state;
        vector<double> error;
        vector<double> action;
        bool supervised;

        /* scout */
        BWAPI::Unit* scout;
        double hp;
        double shield;

        /* loacation */
        BWAPI::Position location;
        //vector<BWAPI::Position> path;

        vector<double> createThreatMap();
        vector<double> getState(); 
        double getReward(BWAPI::Position p);

	  public:
        vector<double> drawVector;
        ofstream res;

        ActorCritic *ac;
        AStar *pathfinder; 
        vector<BWAPI::Position> path;

        Scout(BWAPI::Game*, int range);
        ~Scout(void);

        void save();
        BWAPI::Unit* getScout();
        void setScout(BWAPI::Unit*);
    
        BWAPI::Position getLocation();
        void setLocation(BWAPI::Position location); 
        bool reachedLocation(int);
        BWAPI::Position generateLocation();
        BWAPI::Position getNewLocation(); 
        bool isOutOfMap(); 
       
        static double pathSize(BWAPI::Position start, BWAPI::Position end, vector<BWAPI::Position> path); 
        BWAPI::Position getPosition(vector <double> action);
        BWAPI::TilePosition getTilePosition(BWAPI::Position);

        void move();
        void learn();

        vector<double> getOtherState(BWAPI::Position, double & dist) ;
};
